Index: /exampleparties/simpleboa/src/test/java/geniusweb/exampleparties/simpleboa/SimpleBoaTest.java
===================================================================
--- /exampleparties/simpleboa/src/test/java/geniusweb/exampleparties/simpleboa/SimpleBoaTest.java	(revision 20)
+++ /exampleparties/simpleboa/src/test/java/geniusweb/exampleparties/simpleboa/SimpleBoaTest.java	(revision 21)
@@ -36,11 +36,11 @@
 import geniusweb.bidspace.AllBidsList;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java
===================================================================
--- /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 20)
+++ /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 21)
@@ -16,12 +16,12 @@
 import geniusweb.actions.PartyId;
 import geniusweb.bidspace.AllBidsList;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profileconnection.ProfileConnectionFactory;
Index: /exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/ShaopPartyTest.java
===================================================================
--- /exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/ShaopPartyTest.java	(revision 20)
+++ /exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/ShaopPartyTest.java	(revision 21)
@@ -36,13 +36,13 @@
 import geniusweb.actions.PartyId;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.DiscreteValue;
 import geniusweb.issuevalue.Value;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.progress.ProgressRounds;
Index: /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java
===================================================================
--- /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 20)
+++ /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 21)
@@ -13,12 +13,12 @@
 import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditive;
Index: /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java
===================================================================
--- /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java	(revision 20)
+++ /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java	(revision 21)
@@ -34,11 +34,11 @@
 import geniusweb.bidspace.AllBidsList;
 import geniusweb.connection.ConnectionEnd;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.Settings;
-import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
Index: /party/src/main/java/geniusweb/party/DefaultParty.java
===================================================================
--- /party/src/main/java/geniusweb/party/DefaultParty.java	(revision 20)
+++ /party/src/main/java/geniusweb/party/DefaultParty.java	(revision 21)
@@ -3,5 +3,5 @@
 import geniusweb.actions.Action;
 import geniusweb.connection.ConnectionEnd;
-import geniusweb.party.inform.Inform;
+import geniusweb.inform.Inform;
 import tudelft.utilities.listener.Listener;
 import tudelft.utilities.logging.ReportToLogger;
Index: /party/src/main/java/geniusweb/party/Party.java
===================================================================
--- /party/src/main/java/geniusweb/party/Party.java	(revision 20)
+++ /party/src/main/java/geniusweb/party/Party.java	(revision 21)
@@ -3,5 +3,5 @@
 import geniusweb.actions.Action;
 import geniusweb.connection.Connectable;
-import geniusweb.party.inform.Inform;
+import geniusweb.inform.Inform;
 
 /**
Index: /party/src/test/java/geniusweb/party/inform/ActionDoneTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/inform/ActionDoneTest.java	(revision 20)
+++ /party/src/test/java/geniusweb/party/inform/ActionDoneTest.java	(revision 21)
@@ -21,10 +21,10 @@
 import geniusweb.actions.Accept;
 import geniusweb.actions.PartyId;
+import geniusweb.inform.ActionDone;
+import geniusweb.inform.Inform;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.DiscreteValue;
 import geniusweb.issuevalue.NumberValue;
 import geniusweb.issuevalue.Value;
-import geniusweb.party.inform.ActionDone;
-import geniusweb.party.inform.Inform;
 import tudelft.utilities.junit.GeneralTests;
 
Index: /party/src/test/java/geniusweb/party/inform/AgreementsTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/inform/AgreementsTest.java	(revision 21)
+++ /party/src/test/java/geniusweb/party/inform/AgreementsTest.java	(revision 21)
@@ -0,0 +1,67 @@
+package geniusweb.party.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.HashSet;
+import java.util.List;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Agreements;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import tudelft.utilities.junit.GeneralTests;
+
+public class AgreementsTest extends GeneralTests<Agreements> {
+	private final ObjectMapper jackson = new ObjectMapper();
+	private String jsonstring = "{\"party2\":{\"issuevalues\":{\"i1\":\"v1\"}},\"party1\":{\"issuevalues\":{\"i1\":\"v1\"}}}";
+
+	private Bid bid1 = new Bid("i1", new DiscreteValue("v1"));
+	private Bid bid2 = new Bid("i1", new DiscreteValue("v2"));
+	private PartyId party1 = new PartyId("party1");
+	private PartyId party2 = new PartyId("party2");
+	private PartyId party3 = new PartyId("party3");
+	private Agreements agree1 = new Agreements().with(bid1,
+			new HashSet<>(Arrays.asList(party1, party2)));
+	private Agreements agree1a = new Agreements().with(bid1,
+			new HashSet<>(Arrays.asList(party1, party2)));
+	private Agreements agree1b = new Agreements().with(bid1,
+			new HashSet<>(Arrays.asList(party2, party1)));
+
+	private Agreements agree2 = new Agreements().with(bid2,
+			new HashSet<>(Arrays.asList(party1, party2)));
+	private Agreements agree3 = new Agreements().with(bid1,
+			new HashSet<>(Arrays.asList(party1, party2, party3)));
+
+	@Override
+	public List<List<Agreements>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(agree1, agree1a, agree1b),
+				Arrays.asList(agree2), Arrays.asList(agree3));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"Agreements.*party2.*Bid.*i1=\"v1\".*party1=Bid.*i1=\"v1\".*",
+				"Agreements.*party2.*Bid.*i1=\"v2\".*party1=Bid.*i1=\"v2\".*",
+				"Agreements.*party2.*Bid.*i1=\"v1\".*party1=Bid.*i1=\"v1\".*party3=Bid.*i1=\\\"v1\\\".*");
+	}
+
+	@Test
+	public void serializeTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(agree1));
+		assertEquals(jsonstring, jackson.writeValueAsString(agree1));
+	}
+
+	@Test
+	public void deserializeTest() throws IOException {
+		Agreements act = jackson.readValue(jsonstring, Agreements.class);
+		assertEquals(agree1, act);
+	}
+}
Index: /party/src/test/java/geniusweb/party/inform/FinishedTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/inform/FinishedTest.java	(revision 20)
+++ /party/src/test/java/geniusweb/party/inform/FinishedTest.java	(revision 21)
@@ -8,4 +8,5 @@
 import java.util.Arrays;
 import java.util.HashMap;
+import java.util.HashSet;
 import java.util.List;
 import java.util.Map;
@@ -19,10 +20,12 @@
 import com.fasterxml.jackson.databind.ObjectMapper;
 
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Agreements;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.DiscreteValue;
 import geniusweb.issuevalue.NumberValue;
 import geniusweb.issuevalue.Value;
-import geniusweb.party.inform.Finished;
-import geniusweb.party.inform.Inform;
 import tudelft.utilities.junit.GeneralTests;
 
@@ -31,5 +34,8 @@
 	private Finished finished1, finished1a, finished2, finished3;
 
-	private String asJson = "{\"Finished\":{\"agreedBid\":{\"issuevalues\":{\"issue3\":9012,\"issue2\":1,\"issue1\":\"b\"}}}}";
+	private String asJson = "{\"Finished\":{\"agreements\":{\"party2\":{\"issuevalues\":{\"issue3\":9012,\"issue2\":1,\"issue1\":\"b\"}},\"party1\":{\"issuevalues\":{\"issue3\":9012,\"issue2\":1,\"issue1\":\"b\"}}}}}";
+
+	private PartyId party1 = new PartyId("party1");
+	private PartyId party2 = new PartyId("party2");
 
 	@Before
@@ -57,8 +63,15 @@
 		Bid bidc = new Bid(issuevaluesc);
 
-		finished1 = new Finished(bid);
-		finished1a = new Finished(bid);
-		finished2 = new Finished(bidb);
-		finished3 = new Finished(bidc);
+		Agreements agree = new Agreements().with(bid,
+				new HashSet<>(Arrays.asList(party1, party2)));
+		Agreements agreeb = new Agreements().with(bidb,
+				new HashSet<>(Arrays.asList(party1, party2)));
+		Agreements agreec = new Agreements().with(bidc,
+				new HashSet<>(Arrays.asList(party1, party2)));
+
+		finished1 = new Finished(agree);
+		finished1a = new Finished(agree);
+		finished2 = new Finished(agreeb);
+		finished3 = new Finished(agreec);
 	}
 
@@ -93,4 +106,7 @@
 	public void testDeserialize()
 			throws JsonParseException, JsonMappingException, IOException {
+		// FIXME there seems a disturbing bug in this test,
+		// jackson seems to ignore the @JsonProperty annotation and therefore
+		// this test does not work in some cases.
 		ObjectMapper jackson = new ObjectMapper();
 		Finished p = (Finished) jackson.readValue(asJson, Inform.class);
Index: /party/src/test/java/geniusweb/party/inform/OptInTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/inform/OptInTest.java	(revision 21)
+++ /party/src/test/java/geniusweb/party/inform/OptInTest.java	(revision 21)
@@ -0,0 +1,76 @@
+package geniusweb.party.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.PartyId;
+import geniusweb.actions.Vote;
+import geniusweb.actions.Votes;
+import geniusweb.inform.Inform;
+import geniusweb.inform.OptIn;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import tudelft.utilities.junit.GeneralTests;
+
+public class OptInTest extends GeneralTests<OptIn> {
+
+	private Bid bid1 = new Bid("iss", new DiscreteValue("val1"));
+	private Bid bid2 = new Bid("iss", new DiscreteValue("val2"));
+	private PartyId partyA = new PartyId("partyA");
+	private PartyId partyB = new PartyId("partyB");
+
+	private final Vote voteA1 = new Vote(partyA, bid1, 2);
+	private final Vote voteB1 = new Vote(partyB, bid1, 2);
+	private final Vote voteB2 = new Vote(partyB, bid2, 2);
+
+	private Votes votesA = new Votes(partyA, Arrays.asList(voteA1));
+	private Votes votesB = new Votes(partyB, Arrays.asList(voteB1, voteB2));
+
+	private final OptIn optIn1 = new OptIn(Arrays.asList(votesA, votesB));
+	private final OptIn optIn1a = new OptIn(Arrays.asList(votesA, votesB));
+	private final OptIn optIn2 = new OptIn(Arrays.asList(votesA));
+
+	private String asJson = "{\"OptIn\":{\"votes\":[{\"Votes\":{\"actor\":\"partyA\",\"votes\":[{\"vote\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}},\"minPower\":2}}]}},{\"Votes\":{\"actor\":\"partyB\",\"votes\":[{\"vote\":{\"actor\":\"partyB\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}},\"minPower\":2}},{\"vote\":{\"actor\":\"partyB\",\"bid\":{\"issuevalues\":{\"iss\":\"val2\"}},\"minPower\":2}}]}}]}}";
+
+	@Override
+	public List<List<OptIn>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(optIn1, optIn1a),
+				Arrays.asList(optIn2));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"OptIn.*Votes.*Vote.*partyA.*iss.*val1.*2.*Votes.*Vote.*partyB.*iss.*val1.*.*2.*Vote.*partyB.*iss.*val2.*2.*",
+				"OptIn.*Votes.*Vote.*partyA.*iss.*val.*2.*");
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+		ObjectMapper jackson = new ObjectMapper();
+
+		String json = jackson.writeValueAsString(optIn1);
+		System.out.println(json);
+		assertEquals(asJson, json);
+	}
+
+	@Test
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		Inform p = jackson.readValue(asJson, Inform.class);
+		System.out.println(p);
+		assertEquals(optIn1, p);
+	}
+
+}
Index: /party/src/test/java/geniusweb/party/inform/SettingsTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/inform/SettingsTest.java	(revision 20)
+++ /party/src/test/java/geniusweb/party/inform/SettingsTest.java	(revision 21)
@@ -21,4 +21,6 @@
 
 import geniusweb.actions.PartyId;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
 import geniusweb.progress.ProgressRounds;
 import geniusweb.references.Parameters;
Index: /party/src/test/java/geniusweb/party/inform/VotingTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/inform/VotingTest.java	(revision 21)
+++ /party/src/test/java/geniusweb/party/inform/VotingTest.java	(revision 21)
@@ -0,0 +1,72 @@
+package geniusweb.party.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Voting;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import tudelft.utilities.junit.GeneralTests;
+
+public class VotingTest extends GeneralTests<Voting> {
+
+	private PartyId party1 = new PartyId("party1");
+	private Bid bid1 = new Bid("iss", new DiscreteValue("val1"));
+	private Bid bid2 = new Bid("iss", new DiscreteValue("val2"));
+
+	private Map<PartyId, Integer> powers1 = Collections.singletonMap(party1, 2);
+	private Map<PartyId, Integer> powers2 = Collections.singletonMap(party1, 3);
+
+	private final Voting voting1 = new Voting(Arrays.asList(bid1), powers1);
+	private final Voting voting1a = new Voting(Arrays.asList(bid1), powers1);
+	private final Voting voting2 = new Voting(Arrays.asList(bid2), powers1);
+	private final Voting voting3 = new Voting(Arrays.asList(bid1), powers2);
+
+	private String asJson = "{\"Voting\":{\"bids\":[{\"issuevalues\":{\"iss\":\"val1\"}}],\"powers\":{\"party1\":2}}}";
+
+	@Override
+	public List<List<Voting>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(voting1, voting1a),
+				Arrays.asList(voting2), Arrays.asList(voting3));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("Voting.*Bid.*iss.*val1.*party1.*2.*",
+				"Voting.*Bid.*iss.*val2.*party1.*2.*",
+				"Voting.*Bid.*iss.*val1.*party1.*3.*");
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+		ObjectMapper jackson = new ObjectMapper();
+
+		String json = jackson.writeValueAsString(voting1);
+		System.out.println(json);
+		assertEquals(asJson, json);
+	}
+
+	@Test
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		Inform p = jackson.readValue(asJson, Inform.class);
+		System.out.println(p);
+		assertEquals(voting1, p);
+	}
+
+}
Index: /party/src/test/java/geniusweb/party/inform/YourTurnTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/inform/YourTurnTest.java	(revision 20)
+++ /party/src/test/java/geniusweb/party/inform/YourTurnTest.java	(revision 21)
@@ -16,6 +16,6 @@
 import com.fasterxml.jackson.databind.ObjectMapper;
 
-import geniusweb.party.inform.Inform;
-import geniusweb.party.inform.YourTurn;
+import geniusweb.inform.Inform;
+import geniusweb.inform.YourTurn;
 import tudelft.utilities.junit.GeneralTests;
 
Index: /protocol/src/main/java/geniusweb/protocol/NegoProtocol.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/NegoProtocol.java	(revision 20)
+++ /protocol/src/main/java/geniusweb/protocol/NegoProtocol.java	(revision 21)
@@ -8,4 +8,5 @@
 
 import geniusweb.connection.ConnectionFactory;
+import geniusweb.deadline.Deadline;
 import geniusweb.events.CurrentState;
 import geniusweb.events.ProtocolEvent;
@@ -26,5 +27,5 @@
  * {@link #getDescription()}. A protocol reports the progress through its
  * {@link Listenable} interface. <br>
- * <p>
+ * <h2>General information</h2>
  * 
  * A protocol is mutable because the incoming connections cause state changes.
@@ -33,9 +34,4 @@
  * Because a protocol contains an internal state, it can be used only once.
  * <p>
- * The protocol also needs to keep an eye on the deadline and take appropriate
- * actions when the deadline is reached. <br>
- * <p>
- * A protocol should emit a {@link SessionEnded} or {@link TournamentEnded}
- * event when it is finished.
  * <p>
  * The protocol can emit a {@link CurrentState} event at any time. It should do
@@ -48,8 +44,21 @@
  * {@link #start(SessionSettings, ConnectionFactory)}.
  * 
+ * <h2>Ensure time deadline</h2>
+ * 
+ * The protocol also needs to keep an eye on the deadline and take appropriate
+ * actions when the deadline is reached. <br>
+ * A protocol should emit a {@link SessionEnded} or {@link TournamentEnded}
+ * event when it is finished.
+ * <p>
+ * All protocol implementations must ensure that the deadline is kept and that
+ * the session ends at the agreed time {@link Deadline#getDuration()}. This is
+ * to ensure that the negotiation ends and resources are freed up at or before
+ * some known time.
+ * 
  */
 @JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
 @JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.WRAPPER_OBJECT)
-@JsonSubTypes({ @Type(value = SessionProtocol.class), @Type(value = TournamentProtocol.class) })
+@JsonSubTypes({ @Type(value = SessionProtocol.class),
+		@Type(value = TournamentProtocol.class) })
 
 public interface NegoProtocol extends Listenable<ProtocolEvent> {
@@ -64,13 +73,13 @@
 	 * <p>
 	 * 
-	 * All errors are to be handled through {@link SessionState#getError()} except
-	 * for plain {@link IllegalArgumentException}s. <br>
-	 * The protocol usually uses the incoming connections to keep running. It does
-	 * not need to run in a separate thread or so.
+	 * All errors are to be handled through {@link SessionState#getError()}
+	 * except for plain {@link IllegalArgumentException}s. <br>
+	 * The protocol usually uses the incoming connections to keep running. It
+	 * does not need to run in a separate thread or so.
 	 * 
 	 * 
-	 * @param connectionfactory the {@link ProtocolToPartyConnFactory} that allows
-	 *                          the protocol to connect with the {@link Reference}s
-	 *                          in the settings
+	 * @param connectionfactory the {@link ProtocolToPartyConnFactory} that
+	 *                          allows the protocol to connect with the
+	 *                          {@link Reference}s in the settings
 	 */
 	void start(ProtocolToPartyConnFactory connectionfactory);
@@ -78,7 +87,7 @@
 	/**
 	 * 
-	 * @return a complete description of how this protocol behaves. Presented to the
-	 *         end users who should know negotiation basics but not all technical
-	 *         terms.
+	 * @return a complete description of how this protocol behaves. Presented to
+	 *         the end users who should know negotiation basics but not all
+	 *         technical terms.
 	 */
 	String getDescription();
@@ -86,6 +95,6 @@
 	/**
 	 * @return current state: the results of all sessions run so far and how to
-	 *         continue from that point. Changes over time as the session proceeds.
-	 *         Errors are also stored in the state.
+	 *         continue from that point. Changes over time as the session
+	 *         proceeds. Errors are also stored in the state.
 	 */
 	NegoState getState();
@@ -98,6 +107,7 @@
 
 	/**
-	 * Add a party after the protocol has started. Only some protocols can handle
-	 * this call. Usual protocols take the settings with their constructor.
+	 * Add a party after the protocol has started. Only some protocols can
+	 * handle this call. Usual protocols take the settings with their
+	 * constructor.
 	 * 
 	 * @param party the {@link PartyWithProfile} to be added.
Index: /protocol/src/main/java/geniusweb/protocol/NegoState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/NegoState.java	(revision 20)
+++ /protocol/src/main/java/geniusweb/protocol/NegoState.java	(revision 21)
@@ -5,13 +5,12 @@
 import com.fasterxml.jackson.annotation.JsonSubTypes;
 import com.fasterxml.jackson.annotation.JsonSubTypes.Type;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
 
 import geniusweb.protocol.session.SessionState;
 import geniusweb.protocol.tournament.TournamentState;
 
-import com.fasterxml.jackson.annotation.JsonTypeInfo;
-
 /**
- * The current state of the tournament. Must be serializabl;e so that it can be
- * restarted if a crash occurs.
+ * The current state of the session/tournament. Must be serializabl;e so that it
+ * can be restarted if a crash occurs.
  */
 @JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
@@ -36,9 +35,3 @@
 	boolean isFinal(long currentTimeMs);
 
-	/**
-	 * 
-	 * @return a fatal error occured during the tournament. returns null if no
-	 *         errors occured.
-	 */
-	ProtocolException getError();
 }
Index: /protocol/src/main/java/geniusweb/protocol/ProtocolException.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/ProtocolException.java	(revision 20)
+++ /protocol/src/main/java/geniusweb/protocol/ProtocolException.java	(revision 21)
@@ -2,5 +2,4 @@
 
 import geniusweb.actions.PartyId;
-import geniusweb.party.Party;
 import geniusweb.references.PartyRef;
 
@@ -10,5 +9,6 @@
  */
 public class ProtocolException extends Exception {
-	private String party; // the failing party
+	private static final long serialVersionUID = 4618901784366523980L;
+	private PartyId party; // the failing party
 
 	/**
@@ -17,5 +17,5 @@
 	 *                {@link PartyRef}
 	 */
-	public ProtocolException(String message, String party) {
+	public ProtocolException(String message, PartyId party) {
 		this(message, party, null);
 	}
@@ -30,9 +30,8 @@
 	 * 
 	 * @param message the error message
-	 * @param party   offending party, either the {@link PartyId} or a
-	 *                {@link PartyRef}
+	 * @param party   offending {@link PartyId}
 	 * @param e       the cause of the error
 	 */
-	public ProtocolException(String message, String party, Throwable e) {
+	public ProtocolException(String message, PartyId party, Throwable e) {
 		super(party + ":" + message, e, true, false);
 		this.party = party;
@@ -43,5 +42,5 @@
 	 * @return offending party, either the {@link PartyId} or a {@link PartyRef}
 	 */
-	public String getParty() {
+	public PartyId getParty() {
 		return party;
 	}
Index: /protocol/src/main/java/geniusweb/protocol/WillBeCalled.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/WillBeCalled.java	(revision 21)
+++ /protocol/src/main/java/geniusweb/protocol/WillBeCalled.java	(revision 21)
@@ -0,0 +1,46 @@
+package geniusweb.protocol;
+
+import java.util.concurrent.ScheduledThreadPoolExecutor;
+import java.util.concurrent.TimeUnit;
+import java.util.concurrent.atomic.AtomicBoolean;
+
+/**
+ * Object containing function that will be called exactly once, on demand or at
+ * given deadline.
+ *
+ */
+public class WillBeCalled {
+	private static volatile ScheduledThreadPoolExecutor executor = new ScheduledThreadPoolExecutor(
+			2);
+	private final Runnable runnable;
+	private volatile AtomicBoolean done = new AtomicBoolean(false);
+
+	/**
+	 * @param r       the runnable that will be run once, either when the user
+	 *                calls {@link #complete(Void)} or after delayMs, whichever
+	 *                comes first.
+	 * @param delayMs the delay after this will be called anywa (the 'deadline'
+	 *                in milliseconds. If null, no deadline call will be made
+	 *                and the user must call {@link #complete(Void)} himself.
+	 */
+	public WillBeCalled(Runnable r, Long delayMs) {
+		this.runnable = r;
+		if (delayMs != null) {
+			executor.schedule(() -> complete(), delayMs, TimeUnit.MILLISECONDS);
+		}
+	}
+
+	/**
+	 * Tells the runnable to be executed. Only the first time the function is
+	 * run, subsequent calls do nothing. Failures in runnable are NOT caught
+	 * here, as they are probably bugs
+	 * 
+	 * We must avoid synchronized here because users may use synchronized blocks
+	 * already.
+	 */
+	public void complete() {
+		if (!done.compareAndSet(false, true))
+			return;
+		runnable.run();
+	}
+}
Index: /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConn.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConn.java	(revision 20)
+++ /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConn.java	(revision 21)
@@ -4,5 +4,5 @@
 import geniusweb.actions.PartyId;
 import geniusweb.connection.ConnectionEnd;
-import geniusweb.party.inform.Inform;
+import geniusweb.inform.Inform;
 
 /**
@@ -14,5 +14,5 @@
 	/**
 	 * 
-	 * @return the partyId of the party that this connects to
+	 * @return the partyId of the party that this connects to.
 	 */
 	PartyId getParty();
Index: /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnFactory.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnFactory.java	(revision 20)
+++ /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnFactory.java	(revision 21)
@@ -6,5 +6,5 @@
 import geniusweb.actions.Action;
 import geniusweb.connection.ConnectionFactory;
-import geniusweb.party.inform.Inform;
+import geniusweb.inform.Inform;
 import geniusweb.references.Reference;
 import tudelft.utilities.repository.NoResourcesNowException;
Index: /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnections.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnections.java	(revision 20)
+++ /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnections.java	(revision 21)
@@ -9,10 +9,11 @@
 
 import geniusweb.actions.PartyId;
-import geniusweb.party.inform.Inform;
+import geniusweb.inform.Inform;
 
 /**
  * Contains all parties with their connections. immutable
  */
-public class ProtocolToPartyConnections implements Iterable<ProtocolToPartyConn> {
+public class ProtocolToPartyConnections
+		implements Iterable<ProtocolToPartyConn> {
 	private List<ProtocolToPartyConn> connections;
 
Index: /protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java	(revision 20)
+++ /protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java	(revision 21)
@@ -57,5 +57,5 @@
 	 *                      {@link ProtocolException}s. All errors in our own
 	 *                      code are bugs (not ProtocolExceptions) and should
-	 *                      result in a throw.
+	 *                      result in a throw and terminate the session.
 	 */
 	public DefaultSessionState(List<Action> actions,
@@ -130,5 +130,4 @@
 	}
 
-	@Override
 	public ProtocolException getError() {
 		return error;
